package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.domain.Specifications;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.entities.SatuanIndikator;
import com.jasamedika.medifirst2000.entities.SiklusGizi;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.SiklusGiziService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.SatuanIndikatorVO;
import com.jasamedika.medifirst2000.vo.SiklusGiziVO;

import net.kaczmarzyk.spring.data.jpa.domain.Equal;
import net.kaczmarzyk.spring.data.jpa.web.annotation.Spec;

@RestController
@RequestMapping(value="/siklus-gizi")
public class SiklusGiziController extends LocaleController<SiklusGiziVO>
implements IBaseRestController<SiklusGiziVO>{

	@Autowired
	private SiklusGiziService siklusService;
	
	private static final Logger LOGGER = LoggerFactory
			.getLogger(IndikatorRensarController.class);
	
	@Override
	public ResponseEntity<Collection<SiklusGiziVO>> getAllVOWithQueryString(HttpServletRequest request, Integer page,
			Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<SiklusGiziVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(SiklusGiziVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(SiklusGiziVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<SiklusGiziVO>> getAllVO() {
		return null;
	}

	//Created by Pratama
	//Error karna column siklusKe yang ada di database masih varchar sedangkan di java integer
	@RequestMapping(value="/find-all/", method= RequestMethod.GET,produces = MediaType.APPLICATION_JSON_VALUE)
//	public ResponseEntity<Collection<SiklusGizi>> findAll(
//			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
//			@RequestParam(value = "take", required = false, defaultValue = "100") Integer take,
//			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
//			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
//			@Spec(path = "siklusKe", params = "siklusKe", spec = Equal.class) Specification<SiklusGizi> siklusKe,
//			@Spec(path = "jenisWaktu.id", params = "jenisWaktuId", spec = Equal.class) Specification<SiklusGizi> jenisWaktu,
//			@Spec(path = "kelas.id", params = "kelasId", spec = Equal.class) Specification<SiklusGizi> kelas)
//	{
//			Map<String, Object> result = new HashMap<String, Object>();
//			Specification<SiklusGizi> spec = Specifications.where(siklusKe).and(jenisWaktu).and(kelas);
//			result = siklusService.findAll(page, take, sort,dir, spec);
//			return constructListPageResult(result);
//	}

	public ResponseEntity<Map<String,Object>> findAll(
			@RequestParam(value = "jenisWaktuId", required=false) Integer jenisWaktuId,
			@RequestParam(value = "siklusKe", required=false) Integer siklusKe,
			@RequestParam(value = "kelasId", required=false) Integer kelasId,
			@RequestParam(value = "jenisDietId", required=false) Integer jenisDietId,
			@RequestParam(value = "kategoryProdukId", required=false) Integer kategoryProdukId,
			@RequestParam(value = "bentukProdukId", required=false) Integer bentukProdukId,
			HttpServletRequest request
			){
		try{
			Map<String, Object> result = siklusService.findAll(jenisWaktuId, siklusKe, kelasId, jenisDietId, kategoryProdukId, bentukProdukId);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when get Siklus Gizi", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when get Siklus Gizi", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	// Created by Pratama
	// Belum di tes
	@RequestMapping(value="/save/", method= RequestMethod.POST,produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> save(@Valid @RequestBody List<SiklusGiziVO> vos,HttpServletRequest request){
		try{
			Map<String, Object> result = siklusService.save(vos);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add/update Siklus Gizi", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add/update Siklus Gizi", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
		
	}
}
